#include "stdafx.h"
#include "lottoman.h"
#include "ResultsDlg.h"
#include "HttpDownloadDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//Strings used during the parsing of the Irish Lotto web site
TCHAR* g_pszHTMLMarker = _T("<!--Numbers BEG-->");
TCHAR* g_pszLottonumMarker = _T("lottonum\">");

class CMemberLottoResult
{
public:
//Constructors / Destructors
  CMemberLottoResult() 
  { 
    nWinningBalls = 0; 
    bBonusBall = FALSE; 
  };

//Member variables
  int nWinningBalls; //Number of matches this line has excluding Bonus Ball
  BOOL bBonusBall;   //Did our Bonus ball come up
};


CResultsDlg::CResultsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CResultsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CResultsDlg)
	//}}AFX_DATA_INIT
	m_nNum1 = 0;
	m_nNum2 = 0;
	m_nNum3 = 0;
	m_nNum4 = 0;
	m_nNum5 = 0;
	m_nNum6 = 0;
	m_nNum7 = 0;
  m_pDoc = NULL;
}

void CResultsDlg::DoDataExchange(CDataExchange* pDX)
{
  ASSERT(m_pDoc);

  //Let the base class do its thing
	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CResultsDlg)
	DDX_Control(pDX, IDC_COMBINATIONS, m_ctrlCombinations);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_RESULTS, m_ctrlResults);

  int nTotalNumbersDrawn = m_pDoc->m_nNumbersInDraw + (m_pDoc->m_bBonusNumberPicked ? 1 : 0);

	DDX_Text(pDX, IDC_RESNUM1, m_nNum1);
	DDV_MinMaxInt(pDX, m_nNum1, 1, m_pDoc->m_nMaxLottoNumber);

  if (nTotalNumbersDrawn > 1)
  {
	  DDX_Text(pDX, IDC_RESNUM2, m_nNum2);
	  DDV_MinMaxInt(pDX, m_nNum2, 1, m_pDoc->m_nMaxLottoNumber);
  }

  if (nTotalNumbersDrawn > 2)
  {
	  DDX_Text(pDX, IDC_RESNUM3, m_nNum3);
	  DDV_MinMaxInt(pDX, m_nNum3, 1, m_pDoc->m_nMaxLottoNumber);
  }

  if (nTotalNumbersDrawn > 3)
  {
	  DDX_Text(pDX, IDC_RESNUM4, m_nNum4);
	  DDV_MinMaxInt(pDX, m_nNum4, 1, m_pDoc->m_nMaxLottoNumber);
  }

  if (nTotalNumbersDrawn > 4)
  {
	  DDX_Text(pDX, IDC_RESNUM5, m_nNum5);
	  DDV_MinMaxInt(pDX, m_nNum5, 1, m_pDoc->m_nMaxLottoNumber);
  }

  if (nTotalNumbersDrawn > 5)
  {
	  DDX_Text(pDX, IDC_RESNUM6, m_nNum6);
	  DDV_MinMaxInt(pDX, m_nNum6, 1, m_pDoc->m_nMaxLottoNumber);
  }

  if (nTotalNumbersDrawn > 6)
  {
	  DDX_Text(pDX, IDC_RESNUM7, m_nNum7);
	  DDV_MinMaxInt(pDX, m_nNum7, 1, m_pDoc->m_nMaxLottoNumber);
  }

  if (pDX->m_bSaveAndValidate)
  {
    //Check all numbers are unique
    BOOL bIsUnique = (m_nNum1 != m_nNum2);
    if (nTotalNumbersDrawn > 2)
      bIsUnique = bIsUnique && (m_nNum1 != m_nNum3);
    if (nTotalNumbersDrawn > 3)
      bIsUnique = bIsUnique && (m_nNum1 != m_nNum4);
    if (nTotalNumbersDrawn > 4)
      bIsUnique = bIsUnique && (m_nNum1 != m_nNum5);
    if (nTotalNumbersDrawn > 5)
      bIsUnique = bIsUnique && (m_nNum1 != m_nNum6);
    if (nTotalNumbersDrawn > 6)
      bIsUnique = bIsUnique && (m_nNum1 != m_nNum7);
    if (nTotalNumbersDrawn > 2)
      bIsUnique = bIsUnique && (m_nNum2 != m_nNum3);
    if (nTotalNumbersDrawn > 3)
      bIsUnique = bIsUnique && (m_nNum2 != m_nNum4);
    if (nTotalNumbersDrawn > 4)
      bIsUnique = bIsUnique && (m_nNum2 != m_nNum5);
    if (nTotalNumbersDrawn > 5)
      bIsUnique = bIsUnique && (m_nNum2 != m_nNum6);
    if (nTotalNumbersDrawn > 6)
      bIsUnique = bIsUnique && (m_nNum2 != m_nNum7);
    if (nTotalNumbersDrawn > 3)
      bIsUnique = bIsUnique && (m_nNum3 != m_nNum4);
    if (nTotalNumbersDrawn > 4)
      bIsUnique = bIsUnique && (m_nNum3 != m_nNum5);
    if (nTotalNumbersDrawn > 5)
      bIsUnique = bIsUnique && (m_nNum3 != m_nNum6);
    if (nTotalNumbersDrawn > 6)
      bIsUnique = bIsUnique && (m_nNum3 != m_nNum7);
    if (nTotalNumbersDrawn > 4)
      bIsUnique = bIsUnique && (m_nNum4 != m_nNum5);
    if (nTotalNumbersDrawn > 5)
      bIsUnique = bIsUnique && (m_nNum4 != m_nNum6);
    if (nTotalNumbersDrawn > 6)
      bIsUnique = bIsUnique && (m_nNum4 != m_nNum7);
    if (nTotalNumbersDrawn > 5)
      bIsUnique = bIsUnique && (m_nNum5 != m_nNum6);
    if (nTotalNumbersDrawn > 6)
      bIsUnique = bIsUnique && (m_nNum5 != m_nNum7);
    if (nTotalNumbersDrawn > 6)
      bIsUnique = bIsUnique && (m_nNum6 != m_nNum7);
    if (!bIsUnique)
		{
			AfxMessageBox(IDP_NEED_UNIQUE_NUMBERS);
			pDX->PrepareEditCtrl(IDC_RESNUM1);
			pDX->Fail();
		}
  }
}

BEGIN_MESSAGE_MAP(CResultsDlg, CDialog)
	//{{AFX_MSG_MAP(CResultsDlg)
	ON_BN_CLICKED(IDC_CHECK, OnCheck)
	ON_BN_CLICKED(IDC_LOTTO, OnLotto)
	ON_BN_CLICKED(IDC_PLUS1, OnPlus1)
	ON_BN_CLICKED(IDC_PLUS2, OnPlus2)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_KICKIDLE, OnKickIdle)
  ON_UPDATE_COMMAND_UI(IDC_LOTTO, OnUpdateLotto)
  ON_UPDATE_COMMAND_UI(IDC_PLUS1, OnUpdatePlus1)
  ON_UPDATE_COMMAND_UI(IDC_PLUS2, OnUpdatePlus2)
END_MESSAGE_MAP()

BOOL CResultsDlg::OnInitDialog() 
{
  //let the base class do its thing
	CDialog::OnInitDialog();

  //Disable the relavent edit controls	
  int nTotalNumbersDrawn = m_pDoc->m_nNumbersInDraw + (m_pDoc->m_bBonusNumberPicked ? 1 : 0);
  if (nTotalNumbersDrawn < 2)
  {
    GetDlgItem(IDC_PROMPT_RESNUM2)->EnableWindow(FALSE);
    GetDlgItem(IDC_RESNUM2)->EnableWindow(FALSE);
  }
  if (nTotalNumbersDrawn < 3)
  {
    GetDlgItem(IDC_PROMPT_RESNUM3)->EnableWindow(FALSE);
    GetDlgItem(IDC_RESNUM3)->EnableWindow(FALSE);
  }
  if (nTotalNumbersDrawn < 4)
  {
    GetDlgItem(IDC_PROMPT_RESNUM4)->EnableWindow(FALSE);
    GetDlgItem(IDC_RESNUM4)->EnableWindow(FALSE);
  }
  if (nTotalNumbersDrawn < 5)
  {
    GetDlgItem(IDC_PROMPT_RESNUM5)->EnableWindow(FALSE);
    GetDlgItem(IDC_RESNUM5)->EnableWindow(FALSE);
  }
  if (nTotalNumbersDrawn < 6)
  {
    GetDlgItem(IDC_PROMPT_RESNUM6)->EnableWindow(FALSE);
    GetDlgItem(IDC_RESNUM6)->EnableWindow(FALSE);
  }
  if (nTotalNumbersDrawn < 7)
  {
    GetDlgItem(IDC_PROMPT_RESNUM7)->EnableWindow(FALSE);
    GetDlgItem(IDC_RESNUM7)->EnableWindow(FALSE);
  }


  //Add the items to the check list box
  for (int i=m_pDoc->m_nNumbersInDraw; i>=1; i--)
  {
    CString sItem;
    int nItem;
    if (m_pDoc->m_bBonusNumberPicked && i != m_pDoc->m_nNumbersInDraw)
    {
      sItem.Format(_T("Match %d + Bonus"), i);
      nItem = m_ctrlCombinations.AddString(sItem);
      m_ctrlCombinations.SetCheck(nItem, 1);
    }

    sItem.Format(_T("Match %d"), i);
    nItem = m_ctrlCombinations.AddString(sItem);
    m_ctrlCombinations.SetCheck(nItem, 1);
  }
	
	return TRUE;
}

void CResultsDlg::OnCheck() 
{ 
  //Validate our parameters
  ASSERT(m_pDoc);

  //Get the data from the UI
  if (!UpdateData(TRUE))
     return;

  //Display a wait cursor while we parse the HTML
  CWaitCursor wait;

  //Fill in the "ThisWeekeNumbers" array with with winning numbers
  int nTotalNumbersDrawn = m_pDoc->m_nNumbersInDraw + (m_pDoc->m_bBonusNumberPicked ? 1 : 0);
  int* ThisWeeksNumbers = (int*) _alloca(sizeof(int) * nTotalNumbersDrawn);
  if (nTotalNumbersDrawn > 0)
	  ThisWeeksNumbers[0] = m_nNum1;
  if (nTotalNumbersDrawn > 1)
	  ThisWeeksNumbers[1] = m_nNum2;
  if (nTotalNumbersDrawn > 2)
	  ThisWeeksNumbers[2] = m_nNum3;
  if (nTotalNumbersDrawn > 3)
    ThisWeeksNumbers[3] = m_nNum4;
  if (nTotalNumbersDrawn > 4)
	  ThisWeeksNumbers[4] = m_nNum5;
  if (nTotalNumbersDrawn > 5)
	  ThisWeeksNumbers[5] = m_nNum6;
  if (nTotalNumbersDrawn > 6)
	  ThisWeeksNumbers[6] = m_nNum7;

  //Check the Results
  int nMembers = m_pDoc->NumberOfMembers();
  CMemberLottoResult* pWinningLines = new CMemberLottoResult[nMembers];
  for (int i=0; i<nMembers; i++)
  {
    CMember* pMember = m_pDoc->GetAtMember(i);
    if (pMember->m_bEnabled)
    {
      for (int j=0; j<nTotalNumbersDrawn; j++)
      {
        for (int k=0; k<pMember->m_Numbers.GetSize(); k++)
        {
          if (pMember->m_Numbers[k] == ThisWeeksNumbers[j])
          {
            if (m_pDoc->m_bBonusNumberPicked && (j == (nTotalNumbersDrawn-1)))
              pWinningLines[i].bBonusBall = TRUE;
            else 
              pWinningLines[i].nWinningBalls++;
          }
        }
      }
    }
  }

  //Tally the Results
  int nNumOnes = 0;
  int nNumOnesPlusBonus = 0;
  int nNumTwos = 0;
  int nNumTwosPlusBonus = 0;
  int nNumThrees = 0;
  int nNumThreesPlusBonus = 0;
  int nNumFours = 0;
  int nNumFoursPlusBonus = 0;
  int nNumFives = 0;
  int nNumFivesPlusBonus = 0;
  int nNumSixes = 0;
  for (i=0; i<nMembers; i++)
  {
    if (pWinningLines[i].nWinningBalls == 6)
      ++nNumSixes;
    else if (pWinningLines[i].nWinningBalls == 5 && pWinningLines[i].bBonusBall)
      ++nNumFivesPlusBonus;
    else if (pWinningLines[i].nWinningBalls == 5)
      ++nNumFives;
    else if (pWinningLines[i].nWinningBalls == 4 && pWinningLines[i].bBonusBall)
      ++nNumFoursPlusBonus;
    else if (pWinningLines[i].nWinningBalls == 4)
      ++nNumFours;
    else if (pWinningLines[i].nWinningBalls == 3 && pWinningLines[i].bBonusBall)
      ++nNumThreesPlusBonus;
    else if (pWinningLines[i].nWinningBalls == 3)
      ++nNumThrees;
    else if (pWinningLines[i].nWinningBalls == 2 && pWinningLines[i].bBonusBall)
      ++nNumTwosPlusBonus;
    else if (pWinningLines[i].nWinningBalls == 2)
      ++nNumTwos;
    else if (pWinningLines[i].nWinningBalls == 1 && pWinningLines[i].bBonusBall)
      ++nNumOnesPlusBonus;
    else if (pWinningLines[i].nWinningBalls == 1)
      ++nNumOnes;
  }

  //Display the results in the edit control
  CString sWindowText;

  CString sText;
  if (nNumSixes)
  {
    CString sItem(_T("Match 6"));
    int nItem = m_ctrlCombinations.FindStringExact(-1, sItem);
    if (nItem != LB_ERR && m_ctrlCombinations.GetCheck(nItem))
    {
      sText.Format(_T("%d Match 6\r\n"), nNumSixes);
      sWindowText += sText;
    }
  }
  if (nNumFivesPlusBonus)
  {
    CString sItem(_T("Match 5 + Bonus"));
    int nItem = m_ctrlCombinations.FindStringExact(-1, sItem);
    if (nItem != LB_ERR && m_ctrlCombinations.GetCheck(nItem))
    {
      sText.Format(_T("%d Match 5 + Bonus\r\n"), nNumFivesPlusBonus);
      sWindowText += sText;
    }
  }
  if (nNumFives)
  {
    CString sItem(_T("Match 5"));
    int nItem = m_ctrlCombinations.FindStringExact(-1, sItem);
    if (nItem != LB_ERR && m_ctrlCombinations.GetCheck(nItem))
    {
      sText.Format(_T("%d Match 5's\r\n"), nNumFives);
      sWindowText += sText;
    }
  }
  if (nNumFoursPlusBonus)
  {
    CString sItem(_T("Match 4 + Bonus"));
    int nItem = m_ctrlCombinations.FindStringExact(-1, sItem);
    if (nItem != LB_ERR && m_ctrlCombinations.GetCheck(nItem))
    {
      sText.Format(_T("We have %d Match 4 + Bonus\r\n"), nNumFoursPlusBonus);
      sWindowText += sText;
    }
  }
  if (nNumFours)
  {
    CString sItem(_T("Match 4"));
    int nItem = m_ctrlCombinations.FindStringExact(-1, sItem);
    if (nItem != LB_ERR && m_ctrlCombinations.GetCheck(nItem))
    {
      sText.Format(_T("%d Match 4's\r\n"), nNumFours);
      sWindowText += sText;
    }
  }
  if (nNumThreesPlusBonus)
  {
    CString sItem(_T("Match 3 + Bonus"));
    int nItem = m_ctrlCombinations.FindStringExact(-1, sItem);
    if (nItem != LB_ERR && m_ctrlCombinations.GetCheck(nItem))
    {
      sText.Format(_T("%d Match 3 + Bonus\r\n"), nNumThreesPlusBonus);
      sWindowText += sText;
    }
  }
  if (nNumThrees)
  {
    CString sItem(_T("Match 3"));
    int nItem = m_ctrlCombinations.FindStringExact(-1, sItem);
    if (nItem != LB_ERR && m_ctrlCombinations.GetCheck(nItem))
    {
      sText.Format(_T("%d Match 3's\r\n"), nNumThrees);
      sWindowText += sText;
    }
  }
  if (nNumTwosPlusBonus)
  {
    CString sItem(_T("Match 2 + Bonus"));
    int nItem = m_ctrlCombinations.FindStringExact(-1, sItem);
    if (nItem != LB_ERR && m_ctrlCombinations.GetCheck(nItem))
    {
      sText.Format(_T("%d Match 2 + Bonus\r\n"), nNumTwosPlusBonus);
      sWindowText += sText;
    }
  }
  if (nNumTwos)
  {
    CString sItem(_T("Match 2"));
    int nItem = m_ctrlCombinations.FindStringExact(-1, sItem);
    if (nItem != LB_ERR && m_ctrlCombinations.GetCheck(nItem))
    {
      sText.Format(_T("%d Match 2's\r\n"), nNumTwos);
      sWindowText += sText;
    }
  }
  if (nNumOnesPlusBonus)
  {
    CString sItem(_T("Match 1 + Bonus"));
    int nItem = m_ctrlCombinations.FindStringExact(-1, sItem);
    if (nItem != LB_ERR && m_ctrlCombinations.GetCheck(nItem))
    {
      sText.Format(_T("%d Match 1 + Bonus\r\n"), nNumOnesPlusBonus);
      sWindowText += sText;
    }
  }
  if (nNumOnes)
  {
    CString sItem(_T("Match 1"));
    int nItem = m_ctrlCombinations.FindStringExact(-1, sItem);
    if (nItem != LB_ERR && m_ctrlCombinations.GetCheck(nItem))
    {
      sText.Format(_T("%d Match 1's\r\n"), nNumOnes);
      sWindowText += sText;
    }
  }

  //Iterate through all the tickers and display the names of those winning tickets
  if (sWindowText.GetLength())
    sWindowText += _T("\r\n");

  for (i=0; i<nMembers; i++)
  {
    CMember* pMember = m_pDoc->GetAtMember(i);
    if (pWinningLines[i].nWinningBalls == 6)
    {
      CString sItem(_T("Match 6"));
      int nItem = m_ctrlCombinations.FindStringExact(-1, sItem);
      if (nItem != LB_ERR && m_ctrlCombinations.GetCheck(nItem))
      {
        sText.Format(_T("%s had a Match 6 ticket\r\n"), pMember->m_sName);
        sWindowText += sText;
      }
    }
    else if (pWinningLines[i].nWinningBalls == 5 && pWinningLines[i].bBonusBall)
    {
      CString sItem(_T("Match 5 + Bonus"));
      int nItem = m_ctrlCombinations.FindStringExact(-1, sItem);
      if (nItem != LB_ERR && m_ctrlCombinations.GetCheck(nItem))
      {
        sText.Format(_T("%s had a Match 5 + Bonus\r\n"), pMember->m_sName);
        sWindowText += sText;
      }
    }
    else if (pWinningLines[i].nWinningBalls == 5)
    {
      CString sItem(_T("Match 5"));
      int nItem = m_ctrlCombinations.FindStringExact(-1, sItem);
      if (nItem != LB_ERR && m_ctrlCombinations.GetCheck(nItem))
      {
        sText.Format(_T("%s had a Match 5\r\n"), pMember->m_sName);
        sWindowText += sText;
      }
    }
    else if (pWinningLines[i].nWinningBalls == 4 && pWinningLines[i].bBonusBall)
    {
      CString sItem(_T("Match 4 + Bonus"));
      int nItem = m_ctrlCombinations.FindStringExact(-1, sItem);
      if (nItem != LB_ERR && m_ctrlCombinations.GetCheck(nItem))
      {
        sText.Format(_T("%s had a Match 4 + Bonus\r\n"), pMember->m_sName);
        sWindowText += sText;
      }
    }
    else if (pWinningLines[i].nWinningBalls == 4)
    {
      CString sItem(_T("Match 4"));
      int nItem = m_ctrlCombinations.FindStringExact(-1, sItem);
      if (nItem != LB_ERR && m_ctrlCombinations.GetCheck(nItem))
      {
        sText.Format(_T("%s had a Match 4 ticket\r\n"), pMember->m_sName);
        sWindowText += sText;
      }
    }
    else if (pWinningLines[i].nWinningBalls == 3 && pWinningLines[i].bBonusBall)
    {
      CString sItem(_T("Match 3 + Bonus"));
      int nItem = m_ctrlCombinations.FindStringExact(-1, sItem);
      if (nItem != LB_ERR && m_ctrlCombinations.GetCheck(nItem))
      {
        sText.Format(_T("%s had a Match 3 + Bonus\r\n"), pMember->m_sName);
        sWindowText += sText;
      }
    }
    else if (pWinningLines[i].nWinningBalls == 3)
    {
      CString sItem(_T("Match 3"));
      int nItem = m_ctrlCombinations.FindStringExact(-1, sItem);
      if (nItem != LB_ERR && m_ctrlCombinations.GetCheck(nItem))
      {
        sText.Format(_T("%s had a Match 3\r\n"), pMember->m_sName);
        sWindowText += sText;
      }
    }
    else if (pWinningLines[i].nWinningBalls == 2 && pWinningLines[i].bBonusBall)
    {
      CString sItem(_T("Match 2 + Bonus"));
      int nItem = m_ctrlCombinations.FindStringExact(-1, sItem);
      if (nItem != LB_ERR && m_ctrlCombinations.GetCheck(nItem))
      {
        sText.Format(_T("%s had a Match 2 + Bonus\r\n"), pMember->m_sName);
        sWindowText += sText;
      }
    }
    else if (pWinningLines[i].nWinningBalls == 2)
    {
      CString sItem(_T("Match 2"));
      int nItem = m_ctrlCombinations.FindStringExact(-1, sItem);
      if (nItem != LB_ERR && m_ctrlCombinations.GetCheck(nItem))
      {
        sText.Format(_T("%s had a Match 2\r\n"), pMember->m_sName);
        sWindowText += sText;
      }
    }
    else if (pWinningLines[i].nWinningBalls == 1 && pWinningLines[i].bBonusBall)
    {
      CString sItem(_T("Match 1 + Bonus"));
      int nItem = m_ctrlCombinations.FindStringExact(-1, sItem);
      if (nItem != LB_ERR && m_ctrlCombinations.GetCheck(nItem))
      {
        sText.Format(_T("%s had a Match 1 + Bonus\r\n"), pMember->m_sName);
        sWindowText += sText;
      }
    }
    else if (pWinningLines[i].nWinningBalls == 1)
    {
      CString sItem(_T("Match 1"));
      int nItem = m_ctrlCombinations.FindStringExact(-1, sItem);
      if (nItem != LB_ERR && m_ctrlCombinations.GetCheck(nItem))
      {
        sText.Format(_T("%s had a Match 1\r\n"), pMember->m_sName);
        sWindowText += sText;
      }
    }
  }

  //Delete the memory we allocated
  delete [] pWinningLines;

  if (sWindowText.IsEmpty())
    sWindowText = _T("No Matches Found!");

  //Display the results in the edit control
  m_ctrlResults.SetWindowText(sWindowText);
}

void CResultsDlg::DoLottoUpdateFromWeb(ResultsType type)
{
  CHttpDownloadDlg dlg;
  dlg.m_sURLToDownload = _T("http://www.lotto.ie/prizes_results/prizes.asp");
  dlg.m_bPromptFileOverwrite = FALSE;

  //Generate a temp filename to download into
  TCHAR pszTempPath[_MAX_PATH];
  if (!GetTempPath(_MAX_PATH, pszTempPath))
  {
    CString sError;
    sError.Format(_T("%d"), GetLastError());

    CString sMsg;
    AfxFormatString1(sMsg, IDP_FAIL_GET_TEMP_PATH, sError);
    AfxMessageBox(sMsg);

    return;
  }

  //Generate a temporary name and write out to it
  TCHAR pszTempFile[_MAX_PATH];
  if (GetTempFileName(pszTempPath, _T("LOM"), 0, pszTempFile) == 0)
  {
    CString sError;
    sError.Format(_T("%d"), GetLastError());

    CString sMsg;
    AfxFormatString1(sMsg, IDP_FAIL_GET_TEMP_FILENAME, sError);
    AfxMessageBox(sMsg);

    return;
  }

  dlg.m_sFileToDownloadInto = pszTempFile;  

  if (dlg.DoModal() == IDOK)
  {
    //Display a wait cursor while we parse the HTML
    CWaitCursor wait;

    CString sHtml = ParseForResultsHtml(dlg.m_sFileToDownloadInto, type);
    if (sHtml.GetLength())
    {
      if (ParseResults(sHtml))
      {
        CDataExchange DX(this, FALSE);
        DoDataExchange(&DX);
      }
      else
        AfxMessageBox(IDP_HTML_PARSE_ERROR);
    }
    else
    {
      AfxMessageBox(IDP_HTML_PARSE_ERROR);
    }

    //Delete the temp file
    DeleteFile(dlg.m_sFileToDownloadInto);
  }
}

BOOL CResultsDlg::ParseResults(const CString& sHtml)
{
  CString sLocalHtml(sHtml);
  sLocalHtml.MakeLower();

  int nFind = sLocalHtml.Find(g_pszLottonumMarker);
  if (nFind == -1)
    return FALSE;
  sLocalHtml = sLocalHtml.Right(sLocalHtml.GetLength() - nFind - _tcslen(g_pszLottonumMarker));
  m_nNum1 = _ttoi(sLocalHtml);

  nFind = sLocalHtml.Find(g_pszLottonumMarker);
  if (nFind == -1)
    return FALSE;
  sLocalHtml = sLocalHtml.Right(sLocalHtml.GetLength() - nFind - _tcslen(g_pszLottonumMarker));
  m_nNum2 = _ttoi(sLocalHtml);

  nFind = sLocalHtml.Find(g_pszLottonumMarker);
  if (nFind == -1)
    return FALSE;
  sLocalHtml = sLocalHtml.Right(sLocalHtml.GetLength() - nFind - _tcslen(g_pszLottonumMarker));
  m_nNum3 = _ttoi(sLocalHtml);

  nFind = sLocalHtml.Find(g_pszLottonumMarker);
  if (nFind == -1)
    return FALSE;
  sLocalHtml = sLocalHtml.Right(sLocalHtml.GetLength() - nFind - _tcslen(g_pszLottonumMarker));
  m_nNum4 = _ttoi(sLocalHtml);

  nFind = sLocalHtml.Find(g_pszLottonumMarker);
  if (nFind == -1)
    return FALSE;
  sLocalHtml = sLocalHtml.Right(sLocalHtml.GetLength() - nFind - _tcslen(g_pszLottonumMarker));
  m_nNum5 = _ttoi(sLocalHtml);

  nFind = sLocalHtml.Find(g_pszLottonumMarker);
  if (nFind == -1)
    return FALSE;
  sLocalHtml = sLocalHtml.Right(sLocalHtml.GetLength() - nFind - _tcslen(g_pszLottonumMarker));
  m_nNum6 = _ttoi(sLocalHtml);

  nFind = sLocalHtml.Find(g_pszLottonumMarker);
  if (nFind == -1)
    return FALSE;
  sLocalHtml = sLocalHtml.Right(sLocalHtml.GetLength() - nFind - _tcslen(g_pszLottonumMarker));
  m_nNum7 = _ttoi(sLocalHtml);


  return TRUE;
}

CString CResultsDlg::ParseForResultsHtml(const CString& sFile, ResultsType type)
{
  //The return value
  CString sHtml;

  try
  {
    //Read in the contents of the file
    CFile infile;
    CFileException ex;
    if (infile.Open(sFile, CFile::modeRead | CFile::shareDenyNone, &ex))
    {
      //Get the filesize
      DWORD dwFileLength = infile.GetLength();

      //Read in the entire file contents
      BYTE* byData = new BYTE[dwFileLength + 1];
      UINT nRead = infile.Read(byData, dwFileLength);

      //Null terminate the data
      byData[nRead] = '\0';

      //Convert to a CString
      sHtml = byData;

      //Seek to the right position in the HTML based
      //on the Results type we are looking for
      int nFind = sHtml.Find(g_pszHTMLMarker);
      if (nFind != -1)
      {
        sHtml = sHtml.Right(sHtml.GetLength() - nFind - _tcslen(g_pszHTMLMarker));
   
        if (type == Plus1 || type == Plus2)
        {
          nFind = sHtml.Find(g_pszHTMLMarker);
          if (nFind != -1)
          {
            sHtml = sHtml.Right(sHtml.GetLength() - nFind - _tcslen(g_pszHTMLMarker));

            if (type == Plus2)
            {
              nFind = sHtml.Find(g_pszHTMLMarker);
              if (nFind != -1)
                sHtml = sHtml.Right(sHtml.GetLength() - nFind - _tcslen(g_pszHTMLMarker));
            }
          }
        }
      }
 
      //Free up the memory we used
      delete [] byData;
    }
  }
  catch(CFileException* pEx)
  {
    pEx->Delete();
  }

  return sHtml;
}

void CResultsDlg::OnLotto() 
{
  DoLottoUpdateFromWeb(Lotto);
}

void CResultsDlg::OnUpdateLotto(CCmdUI* pCmdUI)
{
  ASSERT(m_pDoc);
	pCmdUI->Enable(m_pDoc->m_nNumbersInDraw == 6 && m_pDoc->m_bBonusNumberPicked && m_pDoc->m_nMaxLottoNumber == 42);
}

void CResultsDlg::OnPlus1() 
{
	DoLottoUpdateFromWeb(Plus1);
}

void CResultsDlg::OnUpdatePlus1(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(m_pDoc->m_nNumbersInDraw == 6 && m_pDoc->m_bBonusNumberPicked && m_pDoc->m_nMaxLottoNumber == 42);
}

void CResultsDlg::OnPlus2() 
{
	DoLottoUpdateFromWeb(Plus2);
}

void CResultsDlg::OnUpdatePlus2(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(m_pDoc->m_nNumbersInDraw == 6 && m_pDoc->m_bBonusNumberPicked && m_pDoc->m_nMaxLottoNumber == 42);
}

LRESULT CResultsDlg::OnKickIdle(WPARAM /*wp*/, LPARAM /*lCount*/)
{
  //Cause the OnUpdate MFC UI mechanism to work in a dialog
	UpdateDialogControls(this, TRUE);

	return 0;
}
